<?php

  //==============================================================================

  $default_owner  = "";
  $default_group = "users";
  $default_dirs_rights  = "0700";
  $default_files_rights = "0600";

  //==============================================================================

  function CreateDir( $dirname )
    {
      global $owner, $group, $dirs_rights;
      mkdir( $dirname , 0777 ); //
      if ( $owner != "" )
        {
          chown( $dirname , $owner ); //
        }
      if ( $group != "" )
        {
          chgrp( $dirname , $group ); //
        }
      chmod( $dirname , octdec(strval($dirs_rights)) ); //
    }
  function CopySkelFile( $filename )
    {
      global $owner, $group, $files_rights;
      copy( "skel/".$filename , "etc/".$filename ); //
      if ( $owner != "" )
        {
          chown( "etc/".$filename , $owner ); //
        }
      if ( $group != "" )
        {
          chgrp( "etc/".$filename , $group ); //
        }
      chmod( "etc/".$filename , octdec(strval($files_rights)) ); //
    }

  $instalationcomplete = false;
  $rootpassword = $_POST['rootpassword'];
  $owner = $_POST['owner'];
  $group = $_POST['group'];
  $dirs_rights = $_POST['dirs_rights'];
  $files_rights = $_POST['files_rights'];
  $install = $_POST['install'];
  if ( $dirs_rights == "" )
    {
      $dirs_rights = $default_dirs_rights;
    }
  if ( $files_rights == "" )
    {
      $files_rights = $default_files_rights;
    }

  include 'checkinstallation.php';
  if ($UcInstalled)
    {
      echo '<script type="text/javascript">';
      echo '  document.location.href = "index.php";';
      echo '</script>';
      die();
    }
?>

<?php
  if ($install == "1")
    {
      if ( is_dir("./") && is_readable("./") && is_writable("./") )
          {
            CreateDir( "etc" );
            CreateDir( "etc/group" );
            CreateDir( "etc/proc" );
            CreateDir( "dir" );
            CreateDir( "log" );
            CreateDir( "usr" );
            CopySkelFile( "displayowner.config.php" );
            CopySkelFile( "homedirs.config.php" );
            CopySkelFile( "link.config.php" );
            CopySkelFile( "message.inc" );
            CopySkelFile( "newobject.config.php" );
            CopySkelFile( "userdata.config.php" );
            CopySkelFile( "xfiles.config.php" );
            $fhandle = @fopen( 'etc/root.php', 'w' );
            if( $fhandle != false )
              {
                $password = md5($rootpassword);
                fwrite( $fhandle, '<?php' . chr(13) );
                fwrite( $fhandle, '$ConfigMD5Password = \''  . $password . '\';' . chr(13) );
                fwrite( $fhandle, '?>' );
                fclose( $fhandle );
                if ( $owner != "" )
                  {
                    chown( 'etc/root.php' , $owner );
                  }
                if ( $group != "" )
                  {
                    chgrp( 'etc/root.php' , $group );
                  }
                chmod( 'etc/root.php' , octdec(strval($files_rights)) );
              }
            touch( 'etc/'.'installed' );
            if ( $owner != "" )
              {
                chown( 'etc/'.'installed' , $owner );
              }
            if ( $group != "" )
              {
                chgrp( 'etc/'.'installed' , $group );
              }
            chmod( 'etc/'.'installed' , octdec(strval($files_rights)) );
            $instalationcomplete = true;
          }
        else
          {
            echo '<script type="text/javascript">';
            echo '  parent.document.location.href = "install.php";';
            echo '</script>';
            die();
          }
    }
?>

<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
  <meta http-equiv='content-type' content='text/html; charset=iso-8859-2'>
  <link rel='StyleSheet' href='class.css' type='text/css'>
  <?php
    echo '<title>';
    include 'version.inc';
    echo ' - Installation</title>';
  ?>
</head>
<body background='img/blank.jpg' bgcolor='#ffffff'>

<script type='text/javascript'>
  document.oncontextmenu = new Function("return false;");
</script>

<script type='text/javascript'>
  function Step2Submit()
    {
      if ( document.getElementById('step2_rootpassword').value != document.getElementById('step2_rootpassword2').value )
          {
            alert('Passwords do not match.');
            document.getElementById('step2_rootpassword').value = '';
            document.getElementById('step2_rootpassword2').value = '';
            document.getElementById('step2_rootpassword').focus();
          }
        else
          {
            document.getElementById('rootpassword').value = document.getElementById('step2_rootpassword').value;
            document.getElementById('installform').submit();
          }
    }
  function Step3Submit()
    {
      if ( document.getElementById('step3_dirs_rights').value == "" )
          {
            alert('Directories rights are missing.');
            document.getElementById('step3_dirs_rights').value = '';
            document.getElementById('step3_dirs_rights').focus();
          }
        else if ( document.getElementById('step3_files_rights').value == "" )
          {
            alert('Files rights are missing.');
            document.getElementById('step3_files_rights').value = '';
            document.getElementById('step3_files_rights').focus();
          }
        else
          {
            document.getElementById('owner').value = document.getElementById('step3_owner').value;
            document.getElementById('group').value = document.getElementById('step3_group').value;
            document.getElementById('dirs_rights').value = document.getElementById('step3_dirs_rights').value;
            document.getElementById('files_rights').value = document.getElementById('step3_files_rights').value;
            document.getElementById('install').value = "1";
            document.getElementById('installform').submit();
          }
    }
</script>

<table cellpadding='20' cellspacing='0' style='border:0px;'><tr><td>

  <table style='border:0px;' cellspacing='0' cellpadding='0'><tr>
    <td valign='middle'>
      <img src='img/root_install.jpg' border='0' alt=''>
    </td>
    <td valign='middle'>
      <?php
        echo "<big><b>[ INSTALLATION ]</b></big><br>";
      ?>
    </td>
  </td></tr></table>

  <br>
  <br>

  <?php
    $continue = true;
    if (!$instalationcomplete)
        {
          echo "<form id='installform' method='post' action='install.php'>";
          echo "  <input type='hidden' id='rootpassword' name='rootpassword' value=''>";
          echo "  <input type='hidden' id='owner' name='owner' value=''>";
          echo "  <input type='hidden' id='group' name='group' value=''>";
          echo "  <input type='hidden' id='dirs_rights' name='dirs_rights' value=''>";
          echo "  <input type='hidden' id='files_rights' name='files_rights' value=''>";
          echo "  <input type='hidden' id='install' name='install' value=''>";
          echo "</form>";
          echo "<b>";
          echo "Welcome to ";
          include 'version.inc';
          echo "</b><br>";
          echo "<br>";
          echo "This page will guide you through the installation process of UltraCommander. Just follow a three easy steps.<br>";
          echo "<br>";
          echo "<br>";
          echo "<br>";
          echo "<br>";
          echo "<br>";
          echo "<br>";
          echo "<b>[ STEP 1 / 3 ] DIRECTORY</b><br>";
          echo "The main UC directory (./) have to be read- and writable for the webserver process. (ONLY the main directory!)<br>";
          echo "After the installation you can change its rights back.<br>";
          if (!( is_dir("./") && is_readable("./") && is_writable("./") ))
              {
                if (!is_dir("./"))
                  {
                    echo "<b>[ ./ is not a directory ]</b><br>";
                  }
                if (!is_readable("./"))
                  {
                    echo "<b>[ ./ is not readable ]</b><br>";
                  }
                if (!is_writable("./"))
                  {
                    echo "<b>[ ./ is not writable ]</b><br>";
                  }
                echo "<br>";
                echo '<input type="image" style="border-width:0;cursor:pointer" src="img/root_send.jpg" onClick="document.getElementById(\'installform\').submit();">';
                $continue = false;
              }
            else
              {
                echo "<b>[ OK ]</b>";
              }
          echo "<br>";
          echo "<br>";
          echo "<br>";
          echo "<br>";
          echo "<br>";
          echo "<br>";
          if ($continue)
            {
              echo "<b>[ STEP 2 / 3 ] ROOT PASSWORD</b><br>";
              echo "Root password allows you to control whole UC. Don't forget it!<br>";
              if ( $rootpassword == "" )
                  {
                    echo "Please specify the root password:<br>";
                    echo "<input type='password' id='step2_rootpassword' value=''><br>";
                    echo "And verify it:<br>";
                    echo "<input type='password' id='step2_rootpassword2' value=''><br>";
                    echo "<br>";
                    echo '<input type="image" style="border-width:0;cursor:pointer" src="img/root_send.jpg" onClick="Step2Submit();">';
                    $continue = false;
                  }
                else
                  {
                    echo "<b>[ OK ]</b>";
                  }
            }
          echo "<br>";
          echo "<br>";
          echo "<br>";
          echo "<br>";
          echo "<br>";
          echo "<br>";
          if ($continue)
            {
              if ( $install != "1" )
                  {
                    echo '<script type="text/javascript">';
                    echo '  document.getElementById(\'rootpassword\').value = "' . $rootpassword . '";';
                    echo '</script>';
                    echo "<b>[ STEP 3 / 3 ] ADVANCED OPTIONS</b><br>";
                    echo "DO NOT MODIFY ANY OF THESE ENTRIES UNLESS YOU KNOW WHAT YOU ARE DOING.<br>";
                    echo "These options can be used to fit the installation process with the webserver configuration.<br>";
                    echo "Read the manual before using them.";
                    echo "<br>";
                    echo "Owner:<br>";
                    echo "<input type='text' id='step3_owner' value='" . $default_owner . "'> (empty by default)<br>";
                    echo "Group:<br>";
                    echo "<input type='text' id='step3_group' value='" . $default_group . "'> (your primary group - by default: \"users\")<br>";
                    echo "Directories rights:<br>";
                    echo "<input type='text' id='step3_dirs_rights' value='" . $default_dirs_rights . "'><br>";
                    echo "Files rights:<br>";
                    echo "<input type='text' id='step3_files_rights' value='" . $default_files_rights . "'><br>";
                    echo "<br>";
                    echo '<input type="image" style="border-width:0;cursor:pointer" src="img/root_send.jpg" onClick="Step3Submit();">';
                  }
                else
                  {
                    echo "<b>[ OK ]</b>";
                  }
            }
        }
      else
        {
          echo "<br>";
          echo "<b>[ INSTALLATION COMPLETE ]</b><br>";
          echo "<br>";
          echo "<br>";
          echo "Now you can log in with the \"root\" account, change the rest of the configuration and enable the system.<br>";
          echo "Don't forget about changing the rights of the main UC directory if you have let all users to access it!<br>";
          echo "Have a lot of fun.<br>";
          echo "<br>";
          echo "<br>";
          echo "<br>";
          echo '<input type="image" style="border-width:0;cursor:pointer" src="img/login.jpg" onClick="document.location.href=\'index.php\';">';
        }
  ?>

</td></tr></table>

</body>
</html>
