<?php

  //==========================================================
  $RestrictionText = '(account access restriction)';
  //==========================================================

  $nUsernameMinLength = 1;
  $nUsernameMaxLength = 64;
  $nPasswordMinLength = 1;
  $nPasswordMaxLength = 64;
  include 'etc/userdata.config.php';

  function CanRead($cpath)
    {
      global $ConfigReadDirs;
      $res = false;
      $ck = 0;
      while( ($ck<=count($ConfigReadDirs)-1) && ($res==false) )
        {
          if( substr($cpath,0,strlen($ConfigReadDirs[$ck])) == $ConfigReadDirs[$ck] )
            {
              $res = true;
            }
          $ck++;
        }
      return $res;
    }

  function CanWrite($cpath)
    {
      global $ConfigWriteDirs;
      $res = false;
      $ck = 0;
      while( ($ck<=count($ConfigWriteDirs)-1) && ($res==false) )
        {
          if( substr($cpath,0,strlen($ConfigWriteDirs[$ck])) == $ConfigWriteDirs[$ck] )
            {
              $res = true;
            }
          $ck++;
        }
      return $res;
    }

  function IsXFile($cpath)
    {
      global $ConfigXFiles;
      $res = false;
      $cext = '';
      $ck = strlen($cpath);
      while( $ck>=1 && ($cpath{$ck}!='.') )
        {
          $cext = $cpath{$ck} . $cext;
          $ck = $ck - 1;
        }
      $cext = strtolower($cext);
      $ck = 0;
      while( ($ck<=count($ConfigXFiles)-1) && ($res==false) )
        {
          if( $cext == strtolower($ConfigXFiles[$ck]) )
            {
              $res = true;
            }
          $ck++;
        }
      return $res;
    }

  // setting vars
  $ValidLogin = False;

  $UsernameToCheck = $username;
  include 'checkusername.php';

  if( $UsernameCheckResult == true )
    {
      // loading user data
      $LoadUsername = $username;
      include 'loaduser.php';
      // checking password
      if( ($ConfigMD5Password == $password) && ($password!='') )
        {
          $ValidLogin = True;
        }
    }
  $UserNameCheckResult = '';

  include 'checkinstallation.php';
  if( (!$UcInstalled) || ( (!$UcEnabled) && ($username!='root') ) )
    {
      $ValidLogin = False;
    }
  
?>