<?php
  $securitycheckresult = true;
  include 'loaduser.php';
  if( $ConfigSecurityGroup != '' )
    {
      if( file_exists( 'etc/group/' . $ConfigSecurityGroup . '.php' ) )
          {
            $GroupItems = array();
            include 'etc/group/' . $ConfigSecurityGroup . '.php';
            $kk = 0;
            while( ($securitycheckresult) && ($kk<count($GroupItems)) )
              {
                if( file_exists( 'etc/proc/' . $GroupItems[$kk] . '.php' ) )
                    {
                      $SecurityResult = true;
                      $SecurityAction = $securityaction;
                      $SecurityFileTempName = $securityfiletempname;
                      $SecurityFileFullName = $securityfilename;
                      $fileinfo = pathinfo($securityfilename);
                      $SecurityFilePath = $fileinfo['dirname'];
                      $SecurityFileName = $fileinfo['basename'];
                      $SecurityFileExt = $fileinfo['extension'];
                      if ( $securityaction == 'upload' )
                          {
                            $SecurityFileSize = filesize($securityfiletempname);
                          }
                        else
                          {
                            $SecurityFileSize = filesize($securityfilename);
                          }
                      include 'etc/proc/' . $GroupItems[$kk] . '.php';
                      $securitycheckresult = $SecurityResult;
                    }
                  else
                    {
                      $securitycheckresult = false;
                      $LogLine = 'SECURITY ERROR caused by user "'. $username . '": security procedure "' . $GroupItems[$kk]  . '" does not exist.';
                      include 'addlog.php';
                    }
                $kk++;
              }
          }
        else
          {
            $securitycheckresult = false;
            $LogLine = 'SECURITY ERROR caused by user "'. $username . '": security group "' . $ConfigSecurityGroup  . '" does not exist.';
            include 'addlog.php';
          }
    }
  $SecurityResult = false;
  $SecurityAction = '';
  $SecurityFileFullName = '';
  $SecurityFilePath = '';
  $SecurityFileName = '';
  $SecurityFileExt = '';
  $SecurityFileSize = 0;
?>
